Index: /branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/SBC/sbcmod.F90
===================================================================
--- /branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/SBC/sbcmod.F90	(revision 9018)
+++ /branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/SBC/sbcmod.F90	(revision 9019)
@@ -33,6 +33,7 @@
    USE sbcblk         ! surface boundary condition: bulk formulation
    USE sbcice_if      ! surface boundary condition: ice-if sea-ice model
-   USE sbcice_lim     ! surface boundary condition: LIM 3.0 sea-ice model
-   USE sbcice_lim_2   ! surface boundary condition: LIM 2.0 sea-ice model
+#if defined key_lim3
+   USE icestp         ! surface boundary condition: LIM 3.0 sea-ice model
+#endif
    USE sbcice_cice    ! surface boundary condition: CICE    sea-ice model
    USE sbcisf         ! surface boundary condition: ice-shelf
@@ -91,6 +92,6 @@
       NAMELIST/namsbc/ nn_fsbc  ,                                                    &
          &             ln_usr   , ln_flx   , ln_blk       ,                          &
-         &             ln_cpl   , ln_mixcpl, nn_components, nn_limflx,               &
-         &             nn_ice   , nn_ice_embd,                                       &
+         &             ln_cpl   , ln_mixcpl, nn_components,                          &
+         &             nn_ice   , ln_ice_embd,                                       &
          &             ln_traqsr, ln_dm2dc ,                                         &
          &             ln_rnf   , nn_fwb   , ln_ssr   , ln_isf    , ln_apr_dyn ,     &
@@ -118,12 +119,10 @@
 #if defined key_agrif
       IF( Agrif_Root() ) THEN                ! AGRIF zoom (cf r1242: possibility to run without ice in fine grid)
-         IF( lk_lim2 )   nn_ice      = 2
-         IF( lk_lim3 )   nn_ice      = 3
-         IF( lk_cice )   nn_ice      = 4
+         IF( lk_lim3 )   nn_ice      = 2
+         IF( lk_cice )   nn_ice      = 3
       ENDIF
 #else
-      IF( lk_lim2 )   nn_ice      = 2
-      IF( lk_lim3 )   nn_ice      = 3
-      IF( lk_cice )   nn_ice      = 4
+      IF( lk_lim3 )   nn_ice      = 2
+      IF( lk_cice )   nn_ice      = 3
 #endif
       !
@@ -141,8 +140,7 @@
          WRITE(numout,*) '         OASIS coupling (with atm or sas)           lk_oasis      = ', lk_oasis
          WRITE(numout,*) '         components of your executable              nn_components = ', nn_components
-         WRITE(numout,*) '         Multicategory heat flux formulation (LIM3) nn_limflx     = ', nn_limflx
          WRITE(numout,*) '      Sea-ice : '
          WRITE(numout,*) '         ice management in the sbc (=0/1/2/3)       nn_ice        = ', nn_ice
-         WRITE(numout,*) '         ice-ocean embedded/levitating (=0/1/2)     nn_ice_embd   = ', nn_ice_embd
+         WRITE(numout,*) '         ice embedded into ocean                    ln_ice_embd   = ', ln_ice_embd
          WRITE(numout,*) '      Misc. options of sbc : '
          WRITE(numout,*) '         Light penetration in temperature Eq.       ln_traqsr     = ', ln_traqsr
@@ -202,40 +200,18 @@
       CASE( 0 )                        !- no ice in the domain
       CASE( 1 )                        !- Ice-cover climatology ("Ice-if" model)  
-      CASE( 2 )                        !- LIM2 ice model
-         IF( .NOT.( ln_blk .OR. ln_cpl ) )   CALL ctl_stop( 'sbc_init : LIM2 sea-ice model requires ln_blk or ln_cpl = T' )
-      CASE( 3 )                        !- LIM3 ice model
-         IF( nn_ice_embd == 0            )   CALL ctl_stop( 'sbc_init : LIM3 sea-ice models require nn_ice_embd = 1 or 2' )
-      CASE( 4 )                        !- CICE ice model
+      CASE( 2 )                        !- LIM3 ice model
+      CASE( 3 )                        !- CICE ice model
          IF( .NOT.( ln_blk .OR. ln_cpl ) )   CALL ctl_stop( 'sbc_init : CICE sea-ice model requires ln_blk or ln_cpl = T' )
-         IF( nn_ice_embd == 0            )   CALL ctl_stop( 'sbc_init : CICE sea-ice models require nn_ice_embd = 1 or 2' )
          IF( lk_agrif                    )   CALL ctl_stop( 'sbc_init : CICE sea-ice model not currently available with AGRIF' ) 
       CASE DEFAULT                     !- not supported
       END SELECT
       !
-      IF( nn_ice == 3 ) THEN           !- LIM3 case: multi-category flux option
-         IF(lwp) WRITE(numout,*)
-         SELECT CASE( nn_limflx )         ! LIM3 Multi-category heat flux formulation
-         CASE ( -1 )
-            IF(lwp) WRITE(numout,*) '   LIM3: use per-category fluxes (nn_limflx = -1) '
-            IF( ln_cpl )   CALL ctl_stop( 'sbc_init : the chosen nn_limflx for LIM3 in coupled mode must be 0 or 2' )
-         CASE ( 0  )
-            IF(lwp) WRITE(numout,*) '   LIM3: use average per-category fluxes (nn_limflx = 0) '
-         CASE ( 1  )
-            IF(lwp) WRITE(numout,*) '   LIM3: use average then redistribute per-category fluxes (nn_limflx = 1) '
-            IF( ln_cpl )   CALL ctl_stop( 'sbc_init : the chosen nn_limflx for LIM3 in coupled mode must be 0 or 2' )
-         CASE ( 2  )
-            IF(lwp) WRITE(numout,*) '   LIM3: Redistribute a single flux over categories (nn_limflx = 2) '
-            IF( .NOT.ln_cpl )   CALL ctl_stop( 'sbc_init : the chosen nn_limflx for LIM3 in forced mode cannot be 2' )
-         CASE DEFAULT
-            CALL ctl_stop( 'sbcmod: LIM3 option, nn_limflx, should be between -1 and 2' )
-         END SELECT
-      ELSE                             ! other sea-ice model
-         IF( nn_limflx >= 0  )   CALL ctl_warn( 'sbc_init : multi-category flux option (nn_limflx) only available in LIM3' )
-      ENDIF
-      !
       !                       !**  allocate and set required variables
       !
       !                             !* allocate sbc arrays
       IF( sbc_oce_alloc() /= 0 )   CALL ctl_stop( 'sbc_init : unable to allocate sbc_oce arrays' )
+#if ! defined key_lim3 && ! defined key_cice
+      IF( sbc_ice_alloc() /= 0 )   CALL ctl_stop( 'sbc_init : unable to allocate sbc_ice arrays' )
+#endif
       !
       IF( .NOT.ln_isf ) THEN        !* No ice-shelf in the domain : allocate and set to zero
@@ -329,5 +305,5 @@
       IF( ln_ssr      )   CALL sbc_ssr_init            ! Sea-Surface Restoring initialization
       !
-      IF( ln_isf      )   CALL sbc_isf_init               ! Compute iceshelves
+      IF( ln_isf      )   CALL sbc_isf_init            ! Compute iceshelves
       !
                           CALL sbc_rnf_init            ! Runof initialization
@@ -335,9 +311,14 @@
       IF( ln_apr_dyn )    CALL sbc_apr_init            ! Atmo Pressure Forcing initialization
       !
-      IF( nn_ice == 3 )   CALL sbc_lim_init            ! LIM3 initialization
-      !
-      IF( nn_ice == 4 )   CALL cice_sbc_init( nsbc )   ! CICE initialization
-      !
-      IF( ln_wave     )   CALL sbc_wave_init              ! surface wave initialisation
+#if defined key_lim3
+      IF( lk_agrif .AND. nn_ice == 0 ) THEN            ! allocate ice arrays in case agrif + ice-model + no-ice in child grid
+                          IF( sbc_ice_alloc() /= 0 )   CALL ctl_stop('STOP', 'sbc_ice_alloc : unable to allocate arrays' )
+      ELSEIF( nn_ice == 2 ) THEN
+                          CALL ice_init                ! ICE initialization
+      ENDIF
+#endif
+      IF( nn_ice == 3 )   CALL cice_sbc_init( nsbc )   ! CICE initialization
+      !
+      IF( ln_wave     )   CALL sbc_wave_init           ! surface wave initialisation
       !
    END SUBROUTINE sbc_init
@@ -428,8 +409,9 @@
       !
       SELECT CASE( nn_ice )                                       ! Update heat and freshwater fluxes over sea-ice areas
-      CASE(  1 )   ;         CALL sbc_ice_if   ( kt )                ! Ice-cover climatology ("Ice-if" model)
-      CASE(  2 )   ;         CALL sbc_ice_lim_2( kt, nsbc )          ! LIM-2 ice model
-      CASE(  3 )   ;         CALL sbc_ice_lim  ( kt, nsbc )          ! LIM-3 ice model
-      CASE(  4 )   ;         CALL sbc_ice_cice ( kt, nsbc )          ! CICE ice model
+      CASE(  1 )   ;         CALL sbc_ice_if   ( kt )             ! Ice-cover climatology ("Ice-if" model)
+#if defined key_lim3
+      CASE(  2 )   ;         CALL ice_stp  ( kt, nsbc )           ! LIM-3 ice model
+#endif
+      CASE(  3 )   ;         CALL sbc_ice_cice ( kt, nsbc )       ! CICE ice model
       END SELECT
 
@@ -539,5 +521,5 @@
       !!---------------------------------------------------------------------
       !
-      IF( nn_ice == 4 )   CALL cice_sbc_final
+      IF( nn_ice == 3 )   CALL cice_sbc_final
       !
    END SUBROUTINE sbc_final
Index: /branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/SBC/sbcssm.F90
===================================================================
--- /branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/SBC/sbcssm.F90	(revision 9018)
+++ /branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/SBC/sbcssm.F90	(revision 9019)
@@ -121,5 +121,5 @@
          ssu_m(:,:) = ssu_m(:,:) + ub(:,:,1)
          ssv_m(:,:) = ssv_m(:,:) + vb(:,:,1)
-         IF( l_useCT )  THEN    ;   sst_m(:,:) = sst_m(:,:) + eos_pt_from_ct( zts(:,:,jp_tem), zts(:,:,jp_sal) )
+         IF( l_useCT )  THEN     ;   sst_m(:,:) = sst_m(:,:) + eos_pt_from_ct( zts(:,:,jp_tem), zts(:,:,jp_sal) )
          ELSE                    ;   sst_m(:,:) = sst_m(:,:) + zts(:,:,jp_tem)
          ENDIF
@@ -236,5 +236,5 @@
       ENDIF
       !
-      IF( .NOT. l_ssm_mean ) THEN   ! default initialisation. needed by lim_istate
+      IF( .NOT.l_ssm_mean ) THEN   ! default initialisation. needed by iceistate
          !
          IF(lwp) WRITE(numout,*) '   default initialisation of ss._m arrays'
Index: /branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/SBC/sbcwave.F90
===================================================================
--- /branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/SBC/sbcwave.F90	(revision 9018)
+++ /branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/SBC/sbcwave.F90	(revision 9019)
@@ -19,5 +19,5 @@
    USE oce            ! ocean variables
    USE sbc_oce	       ! Surface boundary condition: ocean fields
-   USE zdf_oce,  ONLY : ln_zdfqiao
+   USE zdf_oce,  ONLY : ln_zdfswm
    USE bdy_oce        ! open boundary condition variables
    USE domvvl         ! domain: variable volume layers
@@ -87,7 +87,10 @@
       INTEGER  ::   jj, ji, jk   ! dummy loop argument
       INTEGER  ::   ik           ! local integer 
-      REAL(wp) ::  ztransp, zfac, ztemp, zsp0
-      REAL(wp) ::  zdep_u, zdep_v, zkh_u, zkh_v, zda_u, zda_v
+      REAL(wp) ::  ztransp, zfac, zsp0
+      REAL(wp) ::  zdepth, zsqrt_depth,  zexp_depth, z_two_thirds, zsqrtpi !sqrt of pi
+      REAL(wp) ::  zbot_u, zbot_v, zkb_u, zkb_v, zke3_u, zke3_v, zda_u, zda_v
+      REAL(wp) ::  zstokes_psi_u_bot, zstokes_psi_v_bot
       REAL(wp), DIMENSION(:,:)  , POINTER ::   zk_t, zk_u, zk_v, zu0_sd, zv0_sd   ! 2D workspace
+      REAL(wp), DIMENSION(:,:)  , POINTER ::   zstokes_psi_u_top, zstokes_psi_v_top   ! 2D workspace
       REAL(wp), DIMENSION(:,:,:), POINTER ::   ze3divh                            ! 3D workspace
       !!---------------------------------------------------------------------
@@ -95,6 +98,9 @@
       CALL wrk_alloc( jpi,jpj,jpk,   ze3divh )
       CALL wrk_alloc( jpi,jpj,       zk_t, zk_u, zk_v, zu0_sd, zv0_sd )
-      !
-      !
+      CALL wrk_alloc( jpi,jpj,       zstokes_psi_u_top, zstokes_psi_v_top)
+      !
+      !
+      zsqrtpi = SQRT(rpi)
+      z_two_thirds = 2.0_wp / 3.0_wp
       zfac =  2.0_wp * rpi / 16.0_wp
       DO jj = 1, jpj                ! exp. wave number at t-point    (Eq. (19) in Breivick et al. (2014) )
@@ -106,7 +112,8 @@
                tsd2d(ji,jj) = zsp0
                ! Wavenumber scale
-               zk_t(ji,jj) = ABS( zsp0 ) / MAX( ABS( 5.97_wp*ztransp ) , 0.0000001_wp )
-         END DO
-      END DO      
+               zk_t(ji,jj) =  (1.0_wp-2.0_wp/3.0_wp)*zsp0/MAX(2.0_wp*ztransp,0.0000001_wp)
+         END DO
+      END DO
+      !
       DO jj = 1, jpjm1              ! exp. wave number & Stokes drift velocity at u- & v-points
          DO ji = 1, jpim1
@@ -120,16 +127,42 @@
       !
       !                       !==  horizontal Stokes Drift 3D velocity  ==!
+      DO jj = 1, jpjm1              ! exp. wave number & Stokes drift velocity at u- & v-points
+         DO ji = 1, jpim1
+            zstokes_psi_u_top(ji,jj) = 0._wp
+            zstokes_psi_v_top(ji,jj) = 0._wp
+         END DO
+      END DO
+
       DO jk = 1, jpkm1
          DO jj = 2, jpjm1
             DO ji = 2, jpim1
-               zdep_u = 0.5_wp * ( gdept_n(ji,jj,jk) + gdept_n(ji+1,jj,jk) )
-               zdep_v = 0.5_wp * ( gdept_n(ji,jj,jk) + gdept_n(ji,jj+1,jk) )
-               !                          
-               zkh_u = zk_u(ji,jj) * zdep_u     ! k * depth
-               zkh_v = zk_v(ji,jj) * zdep_v
-               !                                ! Depth attenuation
-               zda_u = EXP( -2.0_wp*zkh_u ) / ( 1.0_wp + 8.0_wp*zkh_u )
-               zda_v = EXP( -2.0_wp*zkh_v ) / ( 1.0_wp + 8.0_wp*zkh_v )
+               zbot_u = 0.5_wp * ( gdepw_n(ji,jj,jk+1) + gdepw_n(ji+1,jj,jk+1) )
+               zbot_v = 0.5_wp * ( gdepw_n(ji,jj,jk+1) + gdepw_n(ji,jj+1,jk+1) )
+               zkb_u = 2.0_wp * zk_u(ji,jj) * zbot_u     ! 2k * bottom depth
+               zkb_v = 2.0_wp * zk_v(ji,jj) * zbot_v     ! 2k * bottom depth
                !
+               zke3_u = MAX(1.e-8_wp, 2.0_wp * zk_u(ji,jj) * e3u_n(ji,jj,jk))     ! 2k * thickness
+               zke3_v = MAX(1.e-8_wp, 2.0_wp * zk_v(ji,jj) * e3v_n(ji,jj,jk))     ! 2k * thickness
+
+               ! Depth attenuation .... do u component first..
+               zdepth=zkb_u
+               zsqrt_depth = SQRT(zdepth)
+               zexp_depth = EXP(-zdepth)
+               zstokes_psi_u_bot = 1.0_wp - zexp_depth  &
+                    & - z_two_thirds*(zsqrtpi*zsqrt_depth*zdepth*ERFC(zsqrt_depth) &
+                    &                  + 1.0_wp - (1.0_wp + zdepth)*zexp_depth)
+               zda_u = (zstokes_psi_u_bot - zstokes_psi_u_top(ji,jj))/zke3_u
+               zstokes_psi_u_top(ji,jj) = zstokes_psi_u_bot
+
+               !         ... and then v component
+               zdepth=zkb_v
+               zsqrt_depth = SQRT(zdepth)
+               zexp_depth = EXP(-zdepth)
+               zstokes_psi_v_bot = 1.0_wp - zexp_depth  &
+                    & - z_two_thirds*(zsqrtpi*zsqrt_depth*zdepth*ERFC(zsqrt_depth) &
+                    &                  + 1.0_wp - (1.0_wp + zdepth)*zexp_depth)
+               zda_v = (zstokes_psi_v_bot - zstokes_psi_v_top(ji,jj))/zke3_v
+               zstokes_psi_v_top(ji,jj) = zstokes_psi_v_bot
+              !
                usd(ji,jj,jk) = zda_u * zu0_sd(ji,jj) * umask(ji,jj,jk)
                vsd(ji,jj,jk) = zda_v * zv0_sd(ji,jj) * vmask(ji,jj,jk)
@@ -137,5 +170,8 @@
          END DO
       END DO   
-      CALL lbc_lnk( usd(:,:,:), 'U', vsd(:,:,:), 'V', -1. )
+      CALL lbc_lnk( usd(:,:,:), 'U', -1. )
+      CALL lbc_lnk( vsd(:,:,:), 'V', -1. )
+
+
       !
       !                       !==  vertical Stokes Drift 3D velocity  ==!
@@ -152,10 +188,12 @@
       END DO
       !
-      IF( .NOT. AGRIF_Root() ) THEN
-         IF( nbondi ==  1 .OR. nbondi == 2 )   ze3divh(nlci-1,   :  ,:) = 0._wp      ! east
-         IF( nbondi == -1 .OR. nbondi == 2 )   ze3divh(  2   ,   :  ,:) = 0._wp      ! west
-         IF( nbondj ==  1 .OR. nbondj == 2 )   ze3divh(  :   ,nlcj-1,:) = 0._wp      ! north
-         IF( nbondj == -1 .OR. nbondj == 2 )   ze3divh(  :   ,  2   ,:) = 0._wp      ! south
-      ENDIF
+#if defined key_agrif
+      IF( .NOT. Agrif_Root() ) THEN
+         IF( nbondi == -1 .OR. nbondi == 2 )   ze3divh( 2:nbghostcells+1,:        ,:) = 0._wp      ! west
+         IF( nbondi ==  1 .OR. nbondi == 2 )   ze3divh( nlci-nbghostcells:nlci-1,:,:) = 0._wp      ! east
+         IF( nbondj == -1 .OR. nbondj == 2 )   ze3divh( :,2:nbghostcells+1        ,:) = 0._wp      ! south
+         IF( nbondj ==  1 .OR. nbondj == 2 )   ze3divh( :,nlcj-nbghostcells:nlcj-1,:) = 0._wp      ! north
+      ENDIF
+#endif
       !
       CALL lbc_lnk( ze3divh, 'T', 1. )
@@ -185,4 +223,5 @@
       CALL wrk_dealloc( jpi,jpj,jpk,   ze3divh )
       CALL wrk_dealloc( jpi,jpj,       zk_t, zk_u, zk_v, zu0_sd, zv0_sd )
+      CALL wrk_dealloc( jpi,jpj,       zstokes_psi_u_top, zstokes_psi_v_top)
       !
    END SUBROUTINE sbc_stokes
@@ -227,5 +266,5 @@
          !
          ! Read also wave number if needed, so that it is available in coupling routines
-         IF( ln_zdfqiao .AND. .NOT.cpl_wnum ) THEN
+         IF( ln_zdfswm .AND. .NOT.cpl_wnum ) THEN
             CALL fld_read( kt, nn_fsbc, sf_wn )          ! read wave parameters from external forcing
             wnum(:,:) = sf_wn(1)%fnow(:,:,1)
@@ -342,8 +381,14 @@
          ALLOCATE( div_sd(jpi,jpj) )
          ALLOCATE( tsd2d (jpi,jpj) )
+
+         ut0sd(:,:) = 0._wp
+         vt0sd(:,:) = 0._wp
+         hsw(:,:) = 0._wp
+         wmp(:,:) = 0._wp
+
          usd(:,:,:) = 0._wp
          vsd(:,:,:) = 0._wp
          wsd(:,:,:) = 0._wp
-         ! Wave number needed only if ln_zdfqiao=T
+         ! Wave number needed only if ln_zdfswm=T
          IF( .NOT. cpl_wnum ) THEN
             ALLOCATE( sf_wn(1), STAT=ierror )           !* allocate and fill sf_wave with sn_wnum
Index: /branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/STO/stopar.F90
===================================================================
--- /branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/STO/stopar.F90	(revision 9018)
+++ /branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/STO/stopar.F90	(revision 9019)
@@ -159,5 +159,5 @@
       INTEGER  :: ji, jj, jk, jsto, jflt
       REAL(wp) :: stomax
-
+      !!----------------------------------------------------------------------
       !
       ! Update 2D stochastic arrays
@@ -235,5 +235,5 @@
          CALL lbc_lnk( sto3d(:,:,:,jsto), sto3d_typ(jsto), sto3d_sgn(jsto) )
       END DO
-
+      !
    END SUBROUTINE sto_par
 
@@ -267,6 +267,15 @@
       REWIND( numnam_cfg )              ! Namelist namdyn_adv in configuration namelist : Momentum advection scheme
       READ  ( numnam_cfg, namsto, IOSTAT = ios, ERR = 902 )
-902   IF( ios /= 0 ) CALL ctl_nam ( ios , 'namsto in configuration namelist', lwp )
+902   IF( ios >  0 ) CALL ctl_nam ( ios , 'namsto in configuration namelist', lwp )
       IF(lwm) WRITE ( numond, namsto )
+
+      IF( .NOT.ln_rststo ) THEN   ! no use of stochastic parameterization
+         IF(lwp) THEN
+            WRITE(numout,*)
+            WRITE(numout,*) 'sto_par_init : NO use of stochastic parameterization'
+            WRITE(numout,*) '~~~~~~~~~~~~'
+         ENDIF
+         RETURN
+      ENDIF
 
       !IF(ln_ens_rst_in) cn_storst_in = cn_mem//cn_storst_in
@@ -673,8 +682,6 @@
       !!                  ***  ROUTINE sto_rst_read  ***
       !!
-
       !! ** Purpose :   read stochastic parameters from restart file
       !!----------------------------------------------------------------------
-
       INTEGER  :: jsto, jseed
       INTEGER(KIND=8)     ::   ziseed(4)           ! RNG seeds in integer type
@@ -683,4 +690,5 @@
       CHARACTER(LEN=9)    ::   clsto3d='sto3d_000' ! stochastic parameter variable name
       CHARACTER(LEN=10)   ::   clseed='seed0_0000' ! seed variable name
+      !!----------------------------------------------------------------------
 
       IF ( jpsto2d > 0 .OR. jpsto3d > 0 ) THEN
Index: /branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/TRA/eosbn2.F90
===================================================================
--- /branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/TRA/eosbn2.F90	(revision 9018)
+++ /branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/TRA/eosbn2.F90	(revision 9019)
@@ -46,5 +46,4 @@
    USE lib_fortran    ! Fortran utilities (allows no signed zero when 'key_nosignedzero' defined)  
    USE prtctl         ! Print control
-   USE wrk_nemo       ! Memory Allocation
    USE lbclnk         ! ocean lateral boundary conditions
    USE timing         ! Timing
@@ -231,5 +230,5 @@
       !!----------------------------------------------------------------------
       !
-      IF( nn_timing == 1 )   CALL timing_start('eos-insitu')
+      IF( ln_timing )   CALL timing_start('eos-insitu')
       !
       SELECT CASE( neos )
@@ -298,5 +297,5 @@
       IF(ln_ctl)   CALL prt_ctl( tab3d_1=prd, clinfo1=' eos-insitu  : ', ovlap=1, kdim=jpk )
       !
-      IF( nn_timing == 1 )   CALL timing_stop('eos-insitu')
+      IF( ln_timing )   CALL timing_stop('eos-insitu')
       !
    END SUBROUTINE eos_insitu
@@ -329,5 +328,5 @@
       !!----------------------------------------------------------------------
       !
-      IF( nn_timing == 1 )   CALL timing_start('eos-pot')
+      IF( ln_timing )   CALL timing_start('eos-pot')
       !
       SELECT CASE ( neos )
@@ -465,5 +464,5 @@
       IF(ln_ctl)   CALL prt_ctl( tab3d_1=prd, clinfo1=' eos-pot: ', tab3d_2=prhop, clinfo2=' pot : ', ovlap=1, kdim=jpk )
       !
-      IF( nn_timing == 1 )   CALL timing_stop('eos-pot')
+      IF( ln_timing )   CALL timing_stop('eos-pot')
       !
    END SUBROUTINE eos_insitu_pot
@@ -491,5 +490,5 @@
       !!----------------------------------------------------------------------
       !
-      IF( nn_timing == 1 )   CALL timing_start('eos2d')
+      IF( ln_timing )   CALL timing_start('eos2d')
       !
       prd(:,:) = 0._wp
@@ -560,5 +559,5 @@
       IF(ln_ctl)   CALL prt_ctl( tab2d_1=prd, clinfo1=' eos2d: ' )
       !
-      IF( nn_timing == 1 )   CALL timing_stop('eos2d')
+      IF( ln_timing )   CALL timing_stop('eos2d')
       !
    END SUBROUTINE eos_insitu_2d
@@ -583,5 +582,5 @@
       !!----------------------------------------------------------------------
       !
-      IF( nn_timing == 1 )   CALL timing_start('rab_3d')
+      IF( ln_timing )   CALL timing_start('rab_3d')
       !
       SELECT CASE ( neos )
@@ -674,5 +673,5 @@
          &                       tab3d_2=pab(:,:,:,jp_sal), clinfo2=' rab_3d_s : ', ovlap=1, kdim=jpk )
       !
-      IF( nn_timing == 1 )   CALL timing_stop('rab_3d')
+      IF( ln_timing )   CALL timing_stop('rab_3d')
       !
    END SUBROUTINE rab_3d
@@ -696,5 +695,5 @@
       !!----------------------------------------------------------------------
       !
-      IF( nn_timing == 1 ) CALL timing_start('rab_2d')
+      IF( ln_timing )   CALL timing_start('rab_2d')
       !
       pab(:,:,:) = 0._wp
@@ -791,5 +790,5 @@
          &                       tab2d_2=pab(:,:,jp_sal), clinfo2=' rab_2d_s : ' )
       !
-      IF( nn_timing == 1 )   CALL timing_stop('rab_2d')
+      IF( ln_timing )   CALL timing_stop('rab_2d')
       !
    END SUBROUTINE rab_2d
@@ -812,5 +811,5 @@
       !!----------------------------------------------------------------------
       !
-      IF( nn_timing == 1 ) CALL timing_start('rab_2d')
+      IF( ln_timing )   CALL timing_start('rab_2d')
       !
       pab(:) = 0._wp
@@ -888,5 +887,5 @@
       END SELECT
       !
-      IF( nn_timing == 1 )   CALL timing_stop('rab_2d')
+      IF( ln_timing )   CALL timing_stop('rab_2d')
       !
    END SUBROUTINE rab_0d
@@ -915,5 +914,5 @@
       !!----------------------------------------------------------------------
       !
-      IF( nn_timing == 1 ) CALL timing_start('bn2')
+      IF( ln_timing )   CALL timing_start('bn2')
       !
       DO jk = 2, jpkm1           ! interior points only (2=< jk =< jpkm1 )
@@ -928,5 +927,5 @@
                pn2(ji,jj,jk) = grav * (  zaw * ( pts(ji,jj,jk-1,jp_tem) - pts(ji,jj,jk,jp_tem) )     &
                   &                    - zbw * ( pts(ji,jj,jk-1,jp_sal) - pts(ji,jj,jk,jp_sal) )  )  &
-                  &            / e3w_n(ji,jj,jk) * tmask(ji,jj,jk)
+                  &            / e3w_n(ji,jj,jk) * wmask(ji,jj,jk)
             END DO
          END DO
@@ -935,5 +934,5 @@
       IF(ln_ctl)   CALL prt_ctl( tab3d_1=pn2, clinfo1=' bn2  : ', ovlap=1, kdim=jpk )
       !
-      IF( nn_timing == 1 )   CALL timing_stop('bn2')
+      IF( ln_timing )   CALL timing_stop('bn2')
       !
    END SUBROUTINE bn2
@@ -963,5 +962,5 @@
       !!----------------------------------------------------------------------
       !
-      IF ( nn_timing == 1 )   CALL timing_start('eos_pt_from_ct')
+      IF( ln_timing )   CALL timing_start('eos_pt_from_ct')
       !
       zdeltaS = 5._wp
@@ -994,5 +993,5 @@
       END DO
       !
-      IF( nn_timing == 1 )   CALL timing_stop('eos_pt_from_ct')
+      IF( ln_timing )   CALL timing_stop('eos_pt_from_ct')
       !
    END FUNCTION eos_pt_from_ct
@@ -1128,5 +1127,5 @@
       !!----------------------------------------------------------------------
       !
-      IF( nn_timing == 1 )   CALL timing_start('eos_pen')
+      IF( ln_timing )   CALL timing_start('eos_pen')
       !
       SELECT CASE ( neos )
@@ -1222,5 +1221,5 @@
       END SELECT
       !
-      IF( nn_timing == 1 )   CALL timing_stop('eos_pen')
+      IF( ln_timing )   CALL timing_stop('eos_pen')
       !
    END SUBROUTINE eos_pen
